#include "csapp.h"

sem_t next, done;

static void *go(void *arg) {
  while (1) {
    P(&next);
    printf("%s", (char *)arg);
    V(&done);
  }
}

int main() {
  pthread_t th1, th2;
  int i;

  Sem_init(&next, 0, 4);
  Sem_init(&done, 0, 0);

  Pthread_create(&th1, NULL, go, "a");
  Pthread_create(&th2, NULL, go, "b");

  for (i = 0; i < 4; i++)
    P(&done);

  return 0;
}
